## org.biojava.bio.gui.sequence
Class AbiTraceRenderer

    java.lang.Object
      org.biojava.utils.AbstractChangeable
          org.biojava.bio.gui.sequence.AbiTraceRenderer

All Implemented Interfaces:
  SequenceRenderer, Changeable

    public class AbiTraceRenderer

extends AbstractChangeable
implements SequenceRenderer

Renders an ABI trace file as a chromatogram graph.

Author:
  Matthew Pocock, Mark Schreiber

Nested Class Summary

Nested classes/interfaces inherited from interface org.biojava.bio.gui.sequence.SequenceRenderer
`SequenceRenderer.RendererForwarder`

Field Summary
`static ChangeType` `DEPTH`
`static ChangeType` `TRACE`

Constructor Summary
`AbiTraceRenderer()`

Method Summary
`double` `getDepth(SequenceRenderContext src)` Retrieve the depth of this renderer when rendering src.
`double` `getMinimumLeader(SequenceRenderContext src)` Retrieve the minimum leading distance for this renderer when rendering src.
`double` `getMinimumTrailer(SequenceRenderContext src)` Retrieve the minimum trailing distance for this renderer when rendering src.
`ABITrace` `getTrace()`
`void` `paint(Graphics2D g, SequenceRenderContext ctxt)` Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.
`SequenceViewerEvent` `processMouseEvent(SequenceRenderContext src, MouseEvent me, List path)` Produce a SequenceViewerEvent in response to a mouse gesture.
`void` `setDepth(double depth)`
`void` `setTrace(ABITrace trace)`

Methods inherited from class org.biojava.utils.AbstractChangeable
`addChangeListener, addChangeListener, generateChangeSupport, getChangeSupport, hasListeners, hasListeners, isUnchanging, removeChangeListener, removeChangeListener`

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Field Detail

### TRACE

    public static final ChangeType TRACE

### DEPTH

    public static final ChangeType DEPTH

Constructor Detail

### AbiTraceRenderer

    public AbiTraceRenderer()

Method Detail

### paint

    public void paint(Graphics2D g,
                      SequenceRenderContext ctxt)

  Description copied from interface: `SequenceRenderer`
  Render a portion (possibly all) of the information for src to g, displaying all of the data that would fall within seqBox.

  Specified by:
    `paint` in interface `SequenceRenderer`
  Parameters:
    `g` - the Graphics2D to render to
    `ctxt` - the SequenceRenderContext that encapsulates the information to render

### setTrace

    public void setTrace(ABITrace trace)
                  throws ChangeVetoException

  Throws:
    `ChangeVetoException`

### getTrace

    public ABITrace getTrace()

### setDepth

    public void setDepth(double depth)
                  throws ChangeVetoException

  Throws:
    `ChangeVetoException`

### getDepth

    public double getDepth(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the depth of this renderer when rendering src.

  The depth may vary between sequence panels - for example based upon sequence length. Each line of information in the SequenceRendererContext only renders a region of the sequence. The depth for one complete line may be different from that for another due to the sequence having more or less information in that region to show. For example, a feature renderer implementation may chose to collapse down to a depth of zero pixels if there are no features to render within a region.

  Specified by:
    `getDepth` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the depth of the renderer for that sequence panel

### getMinimumLeader

    public double getMinimumLeader(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum leading distance for this renderer when rendering src.

  The leading distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumLeader` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the leading distance of the renderer for that sequence panel

### getMinimumTrailer

    public double getMinimumTrailer(SequenceRenderContext src)

  Description copied from interface: `SequenceRenderer`
  Retrieve the minimum trailing distance for this renderer when rendering src.

  The trailing distance may vary between sequence panels - for example based upon sequence length.

  Specified by:
    `getMinimumTrailer` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext to return info for
  Returns:
    the trailing distance of the renderer for that sequence panel

### processMouseEvent

    public SequenceViewerEvent processMouseEvent(SequenceRenderContext src,
                                                 MouseEvent me,
                                                 List path)

  Description copied from interface: `SequenceRenderer`
  Produce a SequenceViewerEvent in response to a mouse gesture.

  A SequenceRenderer that performs any form of coordinate remapping should ensure that it appropriately transforms the mouse event. However, in the SequenceViewerEvent returned, the MouseEvent should be in untransformed coordinates.

  The SequenceRenderer implementation should append itself to the path list before constructing the SequenceViewerEvent.

  Specified by:
    `processMouseEvent` in interface `SequenceRenderer`
  Parameters:
    `src` - the SequenceRenderContext currently in scope
    `me` - a MouseEvent that caused this request
    `path` - the List of SequenceRenderer instances passed through so far
  Returns:
    a SequenceViewerEvent encapsulating the mouse gesture